//+------------------------------------------------------------------+
//|                                                 RSIFilter_v1.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 4
#property indicator_color1 GreenYellow
#property indicator_color2 Coral

#property indicator_color3 Lime
#property indicator_color4 Red

#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
#property indicator_width4 4

//---- input parameters
extern int PeriodRSI=21;
//---- indicator buffers
double UpBuffer[];
double DnBuffer[];
double MUpBuffer[];
double MDnBuffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
   SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
   
   SetIndexBuffer(0,UpBuffer);
   SetIndexBuffer(1,DnBuffer);
   SetIndexBuffer(2,MUpBuffer);
   SetIndexBuffer(3,MDnBuffer);
   
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="RSI Filter("+PeriodRSI+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"UpTrend");
   SetIndexLabel(1,"DownTrend");
//----
   SetIndexDrawBegin(0,PeriodRSI);
   SetIndexDrawBegin(1,PeriodRSI);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int shift,trend;
   double RSI0;
   double fasterEMAnow, slowerEMAnow, fasterEMAprevious, slowerEMAprevious, fasterEMAafter, slowerEMAafter;
   
   for(shift=Bars-PeriodRSI-1;shift>=0;shift--)
   {	
      RSI0=iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,shift);
   	
	   fasterEMAnow = iMA(NULL, 0, 5, 0, MODE_EMA, PRICE_CLOSE, shift);
      slowerEMAnow = iMA(NULL, 0, 12, 0, MODE_EMA, PRICE_CLOSE, shift);
      
      if ((RSI0 > 50)&& (fasterEMAnow > slowerEMAnow)) {
       MUpBuffer[shift]=1.0;
	    MDnBuffer[shift]=0; 
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
      else if (RSI0 > 50) {
	    UpBuffer[shift]=1.0;
	    DnBuffer[shift]=0; 
	    MUpBuffer[shift]=0;
	    MDnBuffer[shift]=0; 
	    }
	   else  if ((RSI0 < 50)&& (slowerEMAnow > fasterEMAnow)) {
	    MDnBuffer[shift]=-1.0; 
	    MUpBuffer[shift]=0;
	    UpBuffer[shift]=0;
	    DnBuffer[shift]=0;
      }
	   else if (RSI0 < 50) 
	    {
	     DnBuffer[shift]=-1.0;
	     UpBuffer[shift]=0; 
	     MUpBuffer[shift]=0;
	     MDnBuffer[shift]=0; 
	    }
	 
	}
	return(0);	
 }

